/*****************************************************************************
 *   extint.h:  Header file for Philips LPC214x Family Microprocessors
 *
 *   Copyright(C) 2006, Philips Semiconductor
 *   All rights reserved.
 *
 *   History
 *   2005.10.01  ver 1.00    Prelimnary version, first Release
 *
******************************************************************************/
#ifndef __EXTINT_H 
#define __EXTINT_H

#define EINT0		0x00000001
#define EINT1		0x00000002
#define EINT2		0x00000004
#define EINT3		0x00000008

#define EINT0_EDGE	0x00000001
#define EINT1_EDGE	0x00000002
#define EINT2_EDGE	0x00000004
#define EINT3_EDGE	0x00000008

#define EINT0_RISING	0x00000001
#define EINT1_RISING	0x00000002
#define EINT2_RISING	0x00000004
#define EINT3_RISING	0x00000008

#define disdable_irq0() VICIntEnClr = 1 << EINT0_INT
#define disdable_irq2() VICIntEnClr = 1 << EINT2_INT
#define disdable_irq3() VICIntEnClr = 1 << EINT3_INT


#define enable_irq0() VICIntEnable = 1 << EINT0_INT
#define enable_irq2() VICIntEnable = 1 << EINT2_INT
#define enable_irq3() VICIntEnable = 1 << EINT3_INT

extern unsigned char bild[24577];
extern unsigned int kadr;

extern __attribute__ ((long_call, section (".fastrun"))) void FIQ_Handler (void) __irq ;

void vd_irq (void) __irq;
void hd_irq (void) __irq;


extern void FirqInit(void);

extern void Kamera_irq_init(void);



#endif /* end __EXTINT_H */
/****************************************************************************
**                            End Of File
*****************************************************************************/

