
#include "LPC214x.h"                        /* LPC21xx definitions */
#include "type.h"
#include "irq.h"
#include "extint.h"
#include "lcd_lib.h"
#include "pm.h"
#include "pwm.h"
#include "led.h"
#include "i2c.h"
#include "kamera.h"
#include "delay.h"

void i2c_scann(void);
void itoa_g (unsigned int i,char * data);


void itoa_g (unsigned int i,char * data)
{
	char d[12];
	
	unsigned int len=0;
	do {
		d[len] = '0' + (i % 10);
		i /= 10;
		len++;
	} while (i);
	
	do {
		*data =d[len-1];
		data++;
		len--;
	}while(len);
	*data=0;
}
void i2c_scann(void)
{
	unsigned int i=0;
	unsigned int ii=0;
	
	char buffer[12];
	
	

	lcd_print (10,120,0xFFFF,0x0,(unsigned char*)"I2C Scann");
	for (i=1;i<128;i++)
	{
		if(i2c_start(i)==0)
		{
			
			lcd_print (10,110-(ii*10),0xFFFF,0x0,"Dev. Found");
			itoa_g(i,&buffer[0]);
			lcd_print (80,110-(ii*10),0xFFFF,0x0,(unsigned char*)buffer);
			ii++;
		}
		
		i2c_stop();

	}
	if (ii==0)
		lcd_print (10,110-(ii*10),0xFFFF,0x0,"Device Not Found !");
	//lcd_print (10,120,0xFFFF,0x0,(unsigned char*)"I2C Scann Ende");
}


int main (void)
{	    	
	unsigned int i;
	unsigned short *daten;
	

	pm_init();
	
	PINSEL2 = 0x0;		/* P1.16~23 GPIO output */
	SCS|=0x3;

	led_install();//LED_ALS_OUTPUT
	led_off();

	lcd_init();
	lcd_cls(lcd_rgb(0,0,255));
	lcd_print (10,120,0xFFFF,lcd_rgb(0,0,255),"LPC 2138");
	
	//*********************************************************************
	udelay(100000);
	PWM_Init();
	
	
	udelay(100000);	
	kamera_reset_out();
	kamera_reset_on();
	udelay(100000);

	i2c_init();
	//i2c_scann();
	
	//kamera_cmmd(0x2,0x0);
	//kamera_cmmd(0x3,0);//0x26
	//kamera_cmmd(0x1e,0x8);

	if(i2c_start(120)==0)
		i2c_write_byte(0x2,0x0);
	else
		lcd_print (10,120,0xFFFF,lcd_rgb(0,0,255),"I2C Error");
	i2c_stop();
	
	if(i2c_start(120)==0)
		i2c_write_byte(0x3,34);//
	else
		lcd_print (10,120,0xFFFF,lcd_rgb(0,0,255),"I2C Error");
	i2c_stop();

	

	if(i2c_start(120)==0)
		i2c_write_byte(0x1E,0x8);
	else
		lcd_print (10,120,0xFFFF,lcd_rgb(0,0,255),"I2C Error");
	i2c_stop();

	udelay(1000);
	PWM_Set(18,9);//1 mhz

	init_VIC();
	FirqInit();
	//Kamera_irq_init();
	
	
	//***************************************************************************
	//128x96
	while( 1 )
	{
		
		

			
			lcd_command(0xEF80);
			lcd_command(0x1804);//0x1800
	  		lcd_command(ASX);
	  		lcd_command(AEX+95);
	  		lcd_command(ASY);
	  		lcd_command(AEY+127);

	  	

			FIOCLR0 = (1<<LCD_RS_GPIO);
			daten= &bild[0];
	  		for (i=0; i<12288; i++)
			{
	  			lcd_data(*daten);
				daten++;
			}
	  		FIOSET0 = (1<<LCD_CS_GPIO);//SEL
		
		
		
	}
 	return 0;
}


