#include "LPC214x.h"                        /* LPC21xx definitions */
#include "type.h"
#include "pwm.h"

void PWM_Init( void)
{
    
	PINSEL1 |= (1<<10);

	PWMTCR = TCR_RESET;		/* Counter Reset */ 
		
	PWMPR = 0;		/* count frequency:Fpclk */
	PWMMCR = PWMMR0R;	/* interrupt on PWMMR0, reset on PWMMR0, reset TC if PWM0 matches */				
	PWMMR0 = 4;
	PWMMR5 = 2;	

	    /* all PWM latch enabled */
	PWMLER =  LER5_EN ;
	PWMPCR =PWMENA5 ;
	PWMTCR = TCR_CNT_EN | TCR_PWM_EN;	/* counter enable, PWM enable */
    
}

void PWM_Set(unsigned int cycle,unsigned int offset)
{
	PWMMR0 = cycle;		/* set PWM cycle */
	PWMMR5 = offset;

	    /* The LER will be cleared when the Match 0 takes place, in order to
	    load and execute the new value of match registers, all the PWMLERs need to
	    reloaded. all PWM latch enabled */
	PWMLER = LER0_EN | LER5_EN ;    
}
